; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Timer 0+1+2 berlauf-Int aktivieren (Timer/Counter Interrupt Mask)			
;																				
TIMER_AKTIVIEREN:
	ldi temp,(0<<OCIE2)|(1<<TOIE2)|(0<<TICIE1)|(0<<OCIE1A)|(0<<OCIE1B)|(0<<TOIE1)|(0<<TOIE0)
	out TIMSK,temp       
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 8-BIT-TIMER																	
;																				
; CS22 CS21 CS20																
;	0 	0 	0 	No clock source (Timer/Counter stopped).						
;	0 	0 	1 	clkT2S/(No prescaling)											
;	0 	1 	0 	clkT2S/8 (From prescaler)										
;	0 	1 	1 	clkT2S/32 (From prescaler)										
;  *1 	0 	0 	clkT2S/64 (From prescaler)										
;	1 	0 	1 	clkT2S/128 (From prescaler)										
;	1 	1 	0 	clkT2S/256 (From prescaler)										
;	1 	1 	1 	clkT2S/1024 (From prescaler)									
;																				
TIMER2_INITIALISIERUNG_1ms:
.equ TIMERWERT2 					=256-125		; (2 hoch 8  minus...) 8MHz VT:64--->125
;.equ TIMERWERT2 					=256-250		; (2 hoch 8  minus...)16MHz VT:64--->250
	ldi temp,(0<<CS22)|(1<<CS21) |(1<<CS20)  
	out TCCR2,temp  
	ldi temp, TIMERWERT2	; TIMER2 Startwert		
	out TCNT2,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1ms																			
TIM2_OVF:
	push TEMP		    	; Sichern von "TEMP" im Stack			
	in	 TEMP,SREG			; Einlesen des SREG 					
	push TEMP	    		; Schreiben von  SREG  im Stack (KOPIE)	
	push TEMP1
;-------------------------------------------------------------------------------
	ldi temp,(TIMERWERT2)
	STS TCNT2,temp
;-------------------------------------------------------------------------------
; Stopuhr																		
	LDS temp ,(adr_STOPPUHR_L)
	LDS temp1,(adr_STOPPUHR_H)
	add temp ,EINS
	adc temp1,NULL
	STS(adr_STOPPUHR_L),temp
	STS(adr_STOPPUHR_H),temp1
;-------------------------------------------------------------------------------
; UHR-ms (Millisekunden)														
	LDS temp ,(adr_ms_L)
	LDS temp1,(adr_ms_H)
	add temp ,EINS
	adc temp1,NULL
	STS(adr_ms_L),temp
	STS(adr_ms_H),temp1
	cpi temp ,low (1000)
	brne TIM2_OVF_FERTIG
	cpi temp1,high(1000)
	brne TIM2_OVF_FERTIG
	STS(adr_ms_L),NULL
	STS(adr_ms_H),NULL
;-------------------------------------------------------------------------------
	rcall UHR				; UHR
;-------------------------------------------------------------------------------
TIM2_OVF_FERTIG:
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
STOPPUHR_NULL:
	STS(adr_STOPPUHR_L),NULL
	STS(adr_STOPPUHR_H),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
UHR:
	LDS temp,(adr_ss)
	inc temp
	STS (adr_ss),temp
	cpi temp,60
	brsh UHR_mm
	ret	
;-------------------------------------------------------------------------------
UHR_mm:
	STS (adr_ss),NULL	; NULL	


	LDS temp,(adr_mm)
	inc temp
	STS (adr_mm),temp
	cpi temp,60
	brsh UHR_hh
	ret	
;-------------------------------------------------------------------------------
UHR_hh:
	STS (adr_mm),NULL	; NULL	

	LDS temp,(adr_hh)
	inc temp
	STS (adr_hh),temp
	cpi temp,24
	brsh UHR_TAG
	ret	
;-------------------------------------------------------------------------------
UHR_TAG:
	STS (adr_hh),NULL	; NULL	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



